// TCPUButton.cpp

/*
* $Log: TCPUButton.cpp,v $
* Revision 1.1  1997/04/05 15:51:45  elvis
* Initial revision
*
*/

#include "TCPUButton.h"
#include "colors.h"

long TCPUButton::mCPUActive=0;
long TCPUButton::mCPUNum=0;

TCPUButton::TCPUButton(long cpu, BRect frame, char *name, char *label, BMessage *msg, ulong mode, ulong flags)
	: BCheckBox(frame, name, label, msg, mode, flags)
{
	if ( mCPUNum == 0 )
	{
		system_info theInfo;
		get_system_info(&theInfo);
		
		mCPUNum = theInfo.cpu_count;
		mCPUActive = 0;
		
		for ( long i=0;i<mCPUNum;i++)
		{
			if (_kget_cpu_state_(i))
				mCPUActive++;
		}
	}
	
	mCPU = cpu;
	if ( cpu >= mCPUNum )
		SetEnabled(false);
	else
	if ( _kget_cpu_state_( cpu ) )
		inherited::SetValue(1);
	else
		inherited::SetValue(0);
	
	mHighlighted = false;
}
	
void
TCPUButton::SetValue(long value)
{

	if ( value == 0 )
	{
		// shutdown the CPU
		
		if ( _kget_cpu_state_(mCPU) == 0 )
		{
			// Already shut down, but decrease the count anyways
			inherited::SetValue(0);
			Invalidate();
			ResetCPUActive();
		}
		else
		{
			ResetCPUActive();
			if ( mCPUActive > 1 )
			{
				_kset_cpu_state_(mCPU,0);
				inherited::SetValue(0);
				mCPUActive--;
				Invalidate();
			}
		}
	}
	else
	{
		// start the CPU
		inherited::SetValue(1);
		_kset_cpu_state_(mCPU,1);
		Invalidate();
		ResetCPUActive();
	}
}

void
TCPUButton::ResetCPUActive()
{
		mCPUActive = 0;
		
		for ( long i=0;i<mCPUNum;i++)
		{
			if (_kget_cpu_state_(i))
				mCPUActive++;
		}
}

void
TCPUButton::Draw(BRect bounds)
{
	if ( IsEnabled() )
	{
		if ( Value() )
		{
			// Draw the on position
			BRect theRect = Bounds();
			
			BeginLineArray(4);
			AddLine( BPoint( theRect.left, theRect.top) , BPoint (theRect.right,theRect.top), white);
			//AddLine( BPoint( theRect.left+1, theRect.top+1) , BPoint (theRect.right-1,theRect.top+1), ltGray);
			AddLine( BPoint( theRect.left, theRect.top) , BPoint (theRect.left,theRect.bottom), white);
			//AddLine( BPoint( theRect.left+1, theRect.top) , BPoint (theRect.left+1,theRect.bottom), ltGray);
			
			AddLine( BPoint( theRect.left+1, theRect.bottom) , BPoint (theRect.right,theRect.bottom), dkGray);
			//AddLine( BPoint( theRect.left+2, theRect.bottom-1) , BPoint (theRect.right-1,theRect.bottom-1), dkGray);
			AddLine( BPoint( theRect.right, theRect.top+1) , BPoint (theRect.right,theRect.bottom), dkGray);
			//AddLine( BPoint( theRect.right-1, theRect.top+2) , BPoint (theRect.right-1,theRect.bottom), dkGray);
			
			EndLineArray();
			
			//theRect.InsetBy(2,2);
			theRect.InsetBy(1,1);
			rgb_color theColor = {100,238,100};
			SetHighColor( theColor);
			FillRect(theRect);
			
			SetDrawingMode(B_OP_OVER);
			SetHighColor(black);
			//DrawChar ( '0' + mCPU , BPoint( theRect.left + 1, theRect.bottom + 1) );
			DrawChar ( '0' + mCPU , BPoint( theRect.left +2, theRect.bottom ) );
			
		}
		else
		{
			// Draw the off position
			BRect theRect = Bounds();
			
			BeginLineArray(4);
			AddLine( BPoint( theRect.left, theRect.top) , BPoint (theRect.right,theRect.top), dkGray);
			//AddLine( BPoint( theRect.left+1, theRect.top+1) , BPoint (theRect.right-1,theRect.top+1), dkGray);
			AddLine( BPoint( theRect.left, theRect.top) , BPoint (theRect.left,theRect.bottom), dkGray);
			//AddLine( BPoint( theRect.left+1, theRect.top) , BPoint (theRect.left+1,theRect.bottom), dkGray);
			
			AddLine( BPoint( theRect.left+1, theRect.bottom) , BPoint (theRect.right,theRect.bottom), white);
			//AddLine( BPoint( theRect.left+2, theRect.bottom-1) , BPoint (theRect.right-1,theRect.bottom-1), ltGray);
			AddLine( BPoint( theRect.right, theRect.top+1) , BPoint (theRect.right,theRect.bottom), white);
			//AddLine( BPoint( theRect.right-1, theRect.top+2) , BPoint (theRect.right-1,theRect.bottom), ltGray);
			
			EndLineArray();
			
			theRect.InsetBy(1,1);
			rgb_color theColor = {238,0,0};
			SetHighColor( theColor);
			FillRect(theRect);
			
			SetDrawingMode(B_OP_OVER);
			SetHighColor(black);
			DrawChar ( '0' + mCPU , BPoint( theRect.left +2, theRect.bottom ) );
		}
	}
	else
	{
			// Draw the on position
			BRect theRect = Bounds();
			
			BeginLineArray(4);
			AddLine( BPoint( theRect.left, theRect.top) , BPoint (theRect.right,theRect.top), ltGray);
			AddLine( BPoint( theRect.left, theRect.top) , BPoint (theRect.left,theRect.bottom), ltGray);
			
			AddLine( BPoint( theRect.left+1, theRect.bottom) , BPoint (theRect.right,theRect.bottom), dkGray);
			AddLine( BPoint( theRect.right, theRect.top+1) , BPoint (theRect.right,theRect.bottom), dkGray);
			
			EndLineArray();
			
			SetDrawingMode(B_OP_OVER);
			SetHighColor(dkGray);
			DrawChar ( '0' + mCPU , BPoint( theRect.left + 3, theRect.bottom -1) );

	}
	
	if (mHighlighted)
	{
		//SetHighColor (dkGray);
		SetHighColor (dkGray);
		StrokeRect( Bounds() );
	}

}

void
TCPUButton::AttachedToWindow()
{
	if (Parent())
		SetViewColor(Parent()->ViewColor());
		
	SetFontName("Kate");
	//SetFontSize(12);
}

void
TCPUButton::Pulse()
{
	if (IsEnabled() )
	{
		if ( _kget_cpu_state_(mCPU) )
		{
			if ( Value() != 1 )
			{
				// Everything is wrong.  Fix it.
				BCheckBox::SetValue(1);
				Invalidate();
			}
		}
		else
		{
			if ( Value() == 1 )
			{
				BCheckBox::SetValue(0);
			}
		}
	}
}

void
TCPUButton::MouseMoved(BPoint inPoint, ulong inState, BMessage *inMsg)
{
	if ( inState == B_ENTERED_VIEW && inMsg == NULL && IsEnabled() )
	{
		mHighlighted = true;
		Invalidate();
	}
	else
	if ( inState == B_EXITED_VIEW && mHighlighted == true )
	{
		mHighlighted = false;
		Invalidate();
	}
}

