// TLedView.h
#pragma once

// This class draws a view which looks like a LED bar display.

class TLedView : public BView
{
public:
	TLedView(BRect frame, char *name, ulong resize);
	
	virtual void 	Draw(BRect frame);
	
			void	DrawMarks(long oldValue, long newValue);
			void	SetScale(long s);
						// Set the scale, s, of each LED bar.  Bar n is
						// lit when (n-1)*s < v <= n*s, where v is 
						// the current value.
			void	SetMax(long m);
						// Set the maximum that value of the LED.
						// Only maximum / scale LED bars will be 
						// drawn.
			void	SetWarningPoint(long p1, long p2);
						// Sets the points at which bars change color.
						// Bars representing values up to p1 are color1.
						// Bars between p1 and p2 are color2.
						// Bars above p2 are color3.
					
			void	SetBarColor1(rgb_color c);
			void	SetBarColor2(rgb_color c);
			void	SetBarColor3(rgb_color c);
			void	SetMarkColor1(rgb_color c);
			void	SetMarkColor2(rgb_color c);
			void	SetMarkColor3(rgb_color c);
						// Sets the color of the bars.  See SetWarningPoint.
						// mark is the color of the marks when they are unlit.
			void	SetCurrentValue(long v);
						// Sets the current value of the LED.  This will 
						// cause the LED to redraw appropriately.
			void	SetBarArea(BRect r) { mBorderRect = r; }
						// Sets the area (in view coordinates) in which
						// the bars will be drawn. 
						// (Nice for making a little frame.)
			
			long	CurrentValue() { return mCurrentValue; }
private:
	long 	mMax;
	long	mScale;
	long	mTicks;
	long	mWarning1;
	long	mWarning2;
	long	mCurrentValue;
	long	mWarningMark1;
	long	mWarningMark2;
	
	BRect	mBorderRect;
	rgb_color	mColor1,mColor2,mColor3,mMarkColor1,mMarkColor2,mMarkColor3;	
};