// TStatsCollector.cpp

/*
* $Log: TStatsCollector.cpp,v $
* Revision 1.1  1997/04/05 15:56:04  elvis
* Initial revision
*
*/

#include "TStatsCollector.h"

TStatsCollector::TStatsCollector(double inMinInterval)
{
	mMinInterval = inMinInterval;
	
	mLastTime = system_time();
	
	mCurrentStructure = 0;

	get_system_info( & mInfo[mCurrentStructure]);
	
	mCPUMax = mInfo[mCurrentStructure].cpu_count * 100;
	
	mCurrentStructure++;
	
}

void
TStatsCollector::Update()
{
	double theTime = system_time();
	double theInterval;
	
	theInterval = theTime - mLastTime;
	if (  theInterval > mMinInterval )
	{
		mCPUTotal = 0;
		
		get_system_info ( &mInfo[mCurrentStructure] );
		
		long theOldStructure = ( mCurrentStructure + 1 ) % 2;
		
		for ( long i =0; i < 8; i++)
		{
			mCPUUsage[i] = (double) (mInfo[mCurrentStructure].cpu_infos[i].active_time - 
							mInfo[theOldStructure].cpu_infos[i].active_time ) /
							theInterval * 100;
			mCPUTotal += mCPUUsage[i];
		}
		
		mLastTime = theTime;
		mCurrentStructure = theOldStructure;
	}
}

system_info*
TStatsCollector::SystemInfo()
{
	return &mInfo[ (mCurrentStructure+1)%2];
}

long
TStatsCollector::GetCPUUtilization(short inCPU)
{
	return mCPUUsage[inCPU];
}

long
TStatsCollector::GetTotalUtilization()
{
	return mCPUTotal;
}

			
		