/*
* $Log: TStatsView.cpp,v $
* Revision 1.1  1997/04/05 15:56:04  elvis
* Initial revision
*
*/

#include "TStatsView.h"
#include <kernel/OS.h>
#include "stdio.h"

#include "TStatsCollector.h"

#include "TCPUButton.h"

#include "T3DFrameView.h"
#include "colors.h"

extern TStatsCollector *gCollector;


TStatsView::TStatsView(BRect inFrame, const char *inName, ulong inResizingMode, ulong inFlags)
	: BView(inFrame, inName, B_FOLLOW_ALL, inFlags)
{
	//Setup the menus	
	mCPULedMenu = new BPopUpMenu("Context Menu",false,false);
	
	mMemLedMenu = new BPopUpMenu("Context Menu",false,false);

	mMiscLedMenu = new BPopUpMenu("Context Menu",false,false);
	
	mCPUGraphMenu = new BPopUpMenu("Context Menu",false,false);
	
	mMemGraphMenu = new BPopUpMenu("Context Menu",false,false);

	// Setup Views
	gCollector->Update();
	system_info *theInfo = gCollector->SystemInfo();
	
	BRect theRect(10,10,35,80);
	BRect theLedRect(0,30,15,60);
	BRect theTextRect;
	theTextRect.top = theLedRect.bottom+5;
	theTextRect.bottom = theTextRect.top + 12;
	long  theSide = 10;
	T3DFrameView *theFrame;
	TLedView *theLed;
	
	theRect.left = theSide;
	theLedRect.OffsetTo( theSide+10, 30);
	theTextRect.left = theLedRect.left-6;
	theTextRect.right = theLedRect.right+6;
	theSide += 35;
	theRect.right = theSide;
	theFrame = CreateFrame(theRect, "CPU", "Cumulative CPU Usage");
	AddChild(theFrame);
	theFrame->SetContextMenu(mCPULedMenu);
	

	mCPULed = new TLedView( theLedRect, "", B_FOLLOW_LEFT | B_FOLLOW_TOP);
	mCPULed->SetMax( gCollector->GetMaxUtilization());
	mCPULed->SetScale( gCollector->GetMaxUtilization() / 10 );
	mCPULed->SetWarningPoint( gCollector->GetMaxUtilization() / 2 , gCollector->GetMaxUtilization() * 8 / 10 );
	AddChild(mCPULed);
	
	mCPULabel = new BStringView(theTextRect,"","");
	mCPULabel->SetAlignment(B_ALIGN_RIGHT);
	AddChild(mCPULabel);


	theSide += 10;
	theLedRect.OffsetTo( theSide+10, 30);
	theTextRect.left = theLedRect.left-5;
	theTextRect.right = theLedRect.right+5;
	theRect.left = theSide;
	theSide += 135;
	theRect.right = theSide;
	theFrame = CreateFrame(theRect, "CPU Detail", "Individual CPU Usage Breakdown");
	AddChild(theFrame);
	theFrame->SetContextMenu(mCPULedMenu);
	
	for ( short i = 0; i<8; i++)
	{
		theLedRect.right = theLedRect.left+10;
		mDetailLed[i] = new TLedView( theLedRect, "", B_FOLLOW_LEFT | B_FOLLOW_TOP);
		AddChild(mDetailLed[i]);
		theLedRect.OffsetBy(15,0);
		
		theLedRect.right = theLedRect.left+15;
		
		BRect theButtonRect(10+i*15,55,20+i*15,65);
		
		TCPUButton *theButton = new TCPUButton(i,theButtonRect,"","",NULL);
		theFrame->AddChild(theButton);

	}
	
	theSide += 10;
	theLedRect.OffsetTo( theSide+10, 30);
	theTextRect.left = theLedRect.left-5;
	theTextRect.right = theLedRect.right+5;
	theRect.left = theSide;
	theSide += 35;
	theRect.right = theSide;
	mMemoryFrame = CreateFrame(theRect, "MEM", "Memory Usage");
	AddChild(mMemoryFrame);
	mMemoryFrame->SetContextMenu(mMemLedMenu);

	mMemoryLed = new TLedView( theLedRect, "", B_FOLLOW_LEFT | B_FOLLOW_TOP);
	mMemoryLed->SetMax( theInfo->max_pages );
	mMemoryLed->SetWarningPoint( theInfo->max_pages * 7 / 10, theInfo->max_pages * 9 / 10 );
	mMemoryLed->SetScale( theInfo->max_pages / 10 );
	AddChild(mMemoryLed);

	mMemoryLabel = new BStringView(theTextRect,"","");
	mMemoryLabel->SetAlignment(B_ALIGN_RIGHT);
	AddChild(mMemoryLabel);
	
	theSide += 10;	
	theLedRect.OffsetTo( theSide+10, 30);
	theTextRect.left = theLedRect.left-5;
	theTextRect.right = theLedRect.right+5;
	theRect.left = theSide;
	theSide += 35;
	theRect.right = theSide;
	mTeamFrame = CreateFrame(theRect, "TMS", "Team Usage");
	AddChild(mTeamFrame);
	mTeamFrame->SetContextMenu(mMiscLedMenu);

	mTeamLed = new TLedView( theLedRect, "", B_FOLLOW_LEFT | B_FOLLOW_TOP);
	mTeamLed->SetMax( theInfo->max_teams );
	mTeamLed->SetWarningPoint( theInfo->max_teams * 7 / 10, theInfo->max_teams * 9 / 10 );
	mTeamLed->SetScale( theInfo->max_teams / 10 );
	AddChild(mTeamLed);

	mTeamLabel = new BStringView(theTextRect,"","");
	mTeamLabel->SetAlignment(B_ALIGN_RIGHT);
	AddChild(mTeamLabel);

	theSide += 10;	
	theLedRect.OffsetTo( theSide+10, 30);
	theTextRect.left = theLedRect.left-5;
	theTextRect.right = theLedRect.right+5;
	theRect.left = theSide;
	theSide += 35;
	theRect.right = theSide;
	mThreadFrame = CreateFrame(theRect, "TDS", "Thread Usage");
	AddChild(mThreadFrame);
	mThreadFrame->SetContextMenu(mMiscLedMenu);

	mThreadLed = new TLedView( theLedRect, "", B_FOLLOW_LEFT | B_FOLLOW_TOP);
	mThreadLed->SetMax( theInfo->max_threads );
	mThreadLed->SetWarningPoint( theInfo->max_threads * 7 / 10, theInfo->max_threads * 9 / 10 );
	mThreadLed->SetScale( theInfo->max_threads / 10 );
	AddChild(mThreadLed);

	mThreadLabel = new BStringView(theTextRect,"","");
	mThreadLabel->SetAlignment(B_ALIGN_RIGHT);
	AddChild(mThreadLabel);

	theSide += 10;	
	theLedRect.OffsetTo( theSide+10, 30);
	theTextRect.left = theLedRect.left-5;
	theTextRect.right = theLedRect.right+5;
	theRect.left = theSide;
	theSide += 35;
	theRect.right = theSide;
	mSemFrame = CreateFrame(theRect, "SEM","Semaphore Usage");
	AddChild(mSemFrame);
	mSemFrame->SetContextMenu(mMiscLedMenu);

	mSemLed = new TLedView( theLedRect, "", B_FOLLOW_LEFT | B_FOLLOW_TOP);
	mSemLed->SetMax( theInfo->max_sems );
	mSemLed->SetWarningPoint( theInfo->max_sems * 7 / 10, theInfo->max_sems * 9 / 10 );
	mSemLed->SetScale( theInfo->max_sems / 10 );
	AddChild(mSemLed);

	mSemLabel = new BStringView(theTextRect,"","");
	mSemLabel->SetAlignment(B_ALIGN_RIGHT);
	AddChild(mSemLabel);
	
	theSide += 10;	
	theLedRect.OffsetTo( theSide+10, 30);
	theTextRect.left = theLedRect.left-5;
	theTextRect.right = theLedRect.right+5;
	theRect.left = theSide;
	theSide += 35;
	theRect.right = theSide;
	mPortFrame = CreateFrame(theRect, "PTS", "Port Usage");
	AddChild(mPortFrame);
	mPortFrame->SetContextMenu(mMiscLedMenu);

	mPortLed = new TLedView( theLedRect, "", B_FOLLOW_LEFT | B_FOLLOW_TOP);
	mPortLed->SetMax( theInfo->max_ports );
	mPortLed->SetWarningPoint( theInfo->max_ports * 7 / 10, theInfo->max_ports * 9 / 10 );
	mPortLed->SetScale( theInfo->max_ports / 10 );
	AddChild(mPortLed);

	mPortLabel = new BStringView(theTextRect,"","");
	mPortLabel->SetAlignment(B_ALIGN_RIGHT);
	AddChild(mPortLabel);
	
	
	// Create the Graphs
	rgb_color theColor = {0,255,0};
	// CPU Graph
	theRect = inFrame;
	theRect.top = 90;
	theRect.bottom = 170;
//	theRect.left = theRect.left+5;
	theRect.right = theRect.right-10;
	theFrame = CreateFrame(theRect, "CPU Utilization Graph", "");
	AddChild(theFrame);
	theFrame->SetContextMenu(mCPUGraphMenu);
	
//	theRect.OffsetTo(0,0);
	theRect.InsetBy(5,5);
	theRect.top = theRect.top +5;
	mCPUGraph = new TGraphView(theRect,"",B_FOLLOW_LEFT|B_FOLLOW_TOP);
	mCPUGraph->SetMinMax( gCollector->GetMaxUtilization() );
	mCPUGraph->SetViewColor( black );
	mCPUGraph->SetLineColor( theColor );
	mCPUGraph->SetLineWidth(2);
	mCPUGraph->SetGridInterval( 50 );
//	theFrame->AddChild(mCPUGraph);
	AddChild(mCPUGraph);
	
	
	// Memory Graph
	theRect = inFrame;
	theRect.top = 180;
	theRect.bottom = 260;
//	theRect.left = theRect.left+5;
	theRect.right = theRect.right-10;	
	theFrame = CreateFrame(theRect, "Memory Utilization Graph", "");
	AddChild(theFrame);
	theFrame->SetContextMenu(mMemGraphMenu);
	
//	theRect.OffsetTo(0,0);
	theRect.InsetBy(5,5);
	theRect.top = theRect.top +5;
	mMemoryGraph = new TGraphView(theRect,"",B_FOLLOW_LEFT|B_FOLLOW_TOP);
	mMemoryGraph->SetViewColor( black );
	mMemoryGraph->SetLineColor( theColor );
	mMemoryGraph->SetLineWidth(2);
	mMemoryGraph->SetMinMax( theInfo->max_pages );
	mMemoryGraph->SetGridInterval( 1024 );
//	theFrame->AddChild(mMemoryGraph);	
	AddChild(mMemoryGraph);	
	
	
	mCPULedTime = 0;
	mCPULedInterval = 300000;
	mMemLedTime = 0;
	mMemLedInterval = 5000000;
	mMiscLedTime = 0;
	mMiscLedInterval = 10000000;
	
	mCPUGraphTime = 0;
	mCPUGraphInterval = 1000000;
	mMemGraphTime = 0;
	mMemGraphInterval = 5000000;

}

TStatsView::~TStatsView()
{
	delete mCPULedMenu;
	delete mMemLedMenu;
	delete mMiscLedMenu;
	delete mCPUGraphMenu;
	delete mMemGraphMenu;
}





void
TStatsView::Pulse()
{
	char theLabel[100];	
	gCollector->Update();
	system_info* theInfo;
	double theTime = system_time();
	
	if ( theTime - mCPULedTime > mCPULedInterval )
	{
		for (long i=0; i< 8; i++)
		{
			mDetailLed[i]->SetCurrentValue( gCollector->GetCPUUtilization(i));
		
		}
		
		mCPULed->SetCurrentValue ( gCollector->GetTotalUtilization());
		
		sprintf(theLabel, "  %d\%", gCollector->GetTotalUtilization());
		mCPULabel->SetText ( theLabel);
		
		
		mCPULedTime = theTime;
	}

	if ( theTime - mMemLedTime > mMemLedInterval )
	{
		
		theInfo = gCollector->SystemInfo();
		
		mMemoryLed->SetCurrentValue( theInfo->used_pages );
				
		sprintf(theLabel, "  %d\%", 100 * theInfo->used_pages / theInfo->max_pages);
		mMemoryLabel->SetText ( theLabel);
			
		sprintf(theLabel, "Memory Usage (%d of %d pages)", theInfo->used_pages, theInfo->max_pages);
		mMemoryFrame->SetCaption(theLabel);

		mMemLedTime = theTime;
	}

	if ( theTime - mMiscLedTime > mMiscLedInterval )
	{		
		theInfo = gCollector->SystemInfo();
		
		mTeamLed->SetCurrentValue( theInfo->used_teams);
		mThreadLed->SetCurrentValue( theInfo->used_threads);
		mSemLed->SetCurrentValue( theInfo->used_sems);
		mPortLed->SetCurrentValue( theInfo->used_ports);
				
		sprintf(theLabel, "  %d\%",100 * theInfo->used_teams / theInfo->max_teams);
		mTeamLabel->SetText ( theLabel);
		sprintf(theLabel, "Team Usage (%d of %d)", theInfo->used_teams, theInfo->max_teams);
		mTeamFrame->SetCaption(theLabel);

		sprintf(theLabel, "  %d\%", 100 * theInfo->used_threads / theInfo->max_threads);
		mThreadLabel->SetText ( theLabel);
		sprintf(theLabel, "Thread Usage (%d of %d)", theInfo->used_threads, theInfo->max_threads);
		mThreadFrame->SetCaption(theLabel);

		sprintf(theLabel, "  %d\%",100 * theInfo->used_sems / theInfo->max_sems);
		mSemLabel->SetText ( theLabel);
		sprintf(theLabel, "Semaphore Usage (%d of %d)", theInfo->used_sems, theInfo->max_sems);
		mSemFrame->SetCaption(theLabel);
		
		sprintf(theLabel, "  %d\%", 100 * theInfo->used_ports / theInfo->max_ports);
		mPortLabel->SetText ( theLabel);
		sprintf(theLabel, "Port Usage (%d of %d)", theInfo->used_ports, theInfo->max_ports);
		mPortFrame->SetCaption(theLabel);
	
		mMiscLedTime = theTime;
	}

	if ( theTime - mCPUGraphTime > mCPUGraphInterval )
	{		
		mCPUGraph->AddPoint( gCollector->GetTotalUtilization() );
		mCPUGraphTime=theTime;
	}
	
	if ( theTime - mMemGraphTime > mMemGraphInterval )
	{	
		theInfo = gCollector->SystemInfo();	
		mMemoryGraph->AddPoint( theInfo->used_pages );
		mMemGraphTime=theTime;
	}


}

void
TStatsView::MessageReceived(BMessage *msg)
{
	switch ( msg->what)
	{
		case 'CL14':	mCPULedInterval = 250000; break;
		case 'CL13':	mCPULedInterval = 330000; break;
		case 'CL12':	mCPULedInterval = 500000; break;
		case 'CL11':	mCPULedInterval = 1000000; break;
		case 'CL21':	mCPULedInterval = 2000000; break;
		case 'CL51':	mCPULedInterval = 5000000; break;
		
		case 'ML13':	mMemLedInterval = 330000; break;
		case 'ML12':	mMemLedInterval = 500000; break;
		case 'ML11':	mMemLedInterval = 1000000; break;
		case 'ML21':	mMemLedInterval = 2000000; break;
		case 'ML51':	mMemLedInterval = 5000000; break;
		case 'ML10':	mMemLedInterval = 10000000; break;
	
		case 'OL13':	mMiscLedInterval = 330000; break;
		case 'OL12':	mMiscLedInterval = 500000; break;
		case 'OL11':	mMiscLedInterval = 1000000; break;
		case 'OL21':	mMiscLedInterval = 2000000; break;
		case 'OL51':	mMiscLedInterval = 5000000; break;
		case 'OL10':	mMiscLedInterval = 10000000; break;
		
		case 'CG12':	mCPUGraphInterval = 500000; break;
		case 'CG11':	mCPUGraphInterval = 1000000; break;
		case 'CG21':	mCPUGraphInterval = 2000000; break;
		case 'CG51':	mCPUGraphInterval = 5000000; break;
		case 'CG10':	mCPUGraphInterval = 10000000; break;
		case 'CG30':	mCPUGraphInterval = 30000000; break;
		
		case 'MG12':	mMemGraphInterval = 500000; break;	
		case 'MG11':	mMemGraphInterval = 1000000; break;
		case 'MG21':	mMemGraphInterval = 2000000; break;
		case 'MG51':	mMemGraphInterval = 5000000; break;
		case 'MG10':	mMemGraphInterval = 10000000; break;
		case 'MG30':	mMemGraphInterval = 30000000; break;
	}
}

void
TStatsView::AttachedToWindow()
{
	NewMenu("CPU LED Update",0,mCPULedMenu);
	NewMenu("1/4 Second",'CL14',mCPULedMenu);	
	NewMenu("1/3 Second",'CL13',mCPULedMenu);	
	NewMenu("1/2 Second",'CL12',mCPULedMenu);	
	NewMenu("1 Second",'CL11',mCPULedMenu);	
	NewMenu("2 Second",'CL21',mCPULedMenu);	
	NewMenu("5 Second",'CL51',mCPULedMenu);
	
	NewMenu("Mem LED Update",0,mMemLedMenu);
	NewMenu("1/3 Second",'ML13',mMemLedMenu);	
	NewMenu("1/2 Second",'ML12',mMemLedMenu);	
	NewMenu("1 Second",'ML11',mMemLedMenu);	
	NewMenu("2 Second",'ML21',mMemLedMenu);	
	NewMenu("5 Second",'ML51',mMemLedMenu);
	NewMenu("10 Second",'ML10',mMemLedMenu);

	NewMenu("Misc LED Update",0,mMiscLedMenu);
	NewMenu("1/3 Second",'OL13',mMiscLedMenu);	
	NewMenu("1/2 Second",'OL12',mMiscLedMenu);	
	NewMenu("1 Second",'OL11',mMiscLedMenu);	
	NewMenu("2 Second",'OL21',mMiscLedMenu);	
	NewMenu("5 Second",'OL51',mMiscLedMenu);
	NewMenu("10 Second",'OL10',mMiscLedMenu);
	
	NewMenu("CPU Graph Update",0,mCPUGraphMenu);
	NewMenu("1/2 Second",'CG12',mCPUGraphMenu);	
	NewMenu("1 Second",'CG11',mCPUGraphMenu);	
	NewMenu("2 Second",'CG21',mCPUGraphMenu);	
	NewMenu("5 Second",'CG51',mCPUGraphMenu);
	NewMenu("10 Second",'CG10',mCPUGraphMenu);
	NewMenu("30 Second",'CG30',mCPUGraphMenu);
	
	NewMenu("Memory Graph Update",0,mMemGraphMenu);
	NewMenu("1/2 Second",'MG12',mMemGraphMenu);	
	NewMenu("1 Second",'MG11',mMemGraphMenu);	
	NewMenu("2 Second",'MG21',mMemGraphMenu);	
	NewMenu("5 Second",'MG51',mMemGraphMenu);
	NewMenu("10 Second",'MG10',mMemGraphMenu);
	NewMenu("30 Second",'MG30',mMemGraphMenu);
}

T3DFrameView*
TStatsView::CreateFrame(BRect inFrame, char *name, char*inCaption)
{
	T3DFrameView *theFrame = new T3DFrameView ( inFrame, name, B_FOLLOW_LEFT|B_FOLLOW_TOP, 1, T_ALL_SIDES );
	theFrame->SetViewColor(mdGray);
	theFrame->SetDark(dkGray);
	theFrame->SetLight(white);
	theFrame->SetMid(ltGray);
	theFrame->SetInverted(true);
	theFrame->SetLeftLabelLead(3);
	theFrame->SetLabelCentered (true);
	theFrame->SetCaption(inCaption);
	
	return theFrame;
}

void
TStatsView::NewMenu(char * name, ulong what, BMenu *menu)
{
	BMenuItem *item;
	
	if ( what == 0 )
	{
		item = new BMenuItem(name,NULL);
		item->SetEnabled(false);
		menu->AddItem(item);
	}
	else
	{
		item = new BMenuItem(name, new BMessage (what));
		item->SetTarget(this);
		menu->AddItem(item);
	}
}
