#pragma once

#include "TGraphView.h"
#include "TLedView.h"

class T3DFrameView;

class TStatsView : public BView
{
public:
			TStatsView(BRect inFrame, const char *inName, ulong inresizingMode, ulong inFlags);
	virtual ~TStatsView();
	virtual void 	Pulse();
	virtual void 	MessageReceived(BMessage*);
	virtual void 	AttachedToWindow();
private:

T3DFrameView*	CreateFrame(BRect inFrame, char *name, char *caption);
void			NewMenu(char *, ulong, BMenu*);
	
T3DFrameView	*mMemoryFrame;
T3DFrameView	*mTeamFrame;
T3DFrameView	*mThreadFrame;
T3DFrameView	*mSemFrame;
T3DFrameView	*mPortFrame;	

TLedView		*mCPULed;
TLedView		*mDetailLed[8];
TLedView		*mMemoryLed;
TLedView		*mTeamLed;
TLedView		*mThreadLed;
TLedView		*mSemLed;
TLedView		*mPortLed;

BStringView		*mCPULabel;
BStringView		*mDetailLabel[8];
BStringView		*mMemoryLabel;
BStringView		*mTeamLabel;
BStringView		*mThreadLabel;
BStringView		*mSemLabel;
BStringView		*mPortLabel;

TGraphView		*mCPUGraph,*mMemoryGraph;

double			mCPULedTime,mCPULedInterval;
double			mMemLedTime,mMemLedInterval;
double			mMiscLedTime,mMiscLedInterval;
double			mCPUGraphTime,mCPUGraphInterval;
double			mMemGraphTime,mMemGraphInterval;

BPopUpMenu		*mCPULedMenu;
BPopUpMenu		*mMemLedMenu;
BPopUpMenu		*mMiscLedMenu;
BPopUpMenu		*mCPUGraphMenu;
BPopUpMenu		*mMemGraphMenu;
};
