//TTabView.h

// Tab Control to switch between multiple views.

// TTabView implements a folder tab control which allows easy access
// to multiple "stacked" view.  Just add childern as normal and they
// will show up as tabs.  Or, add them using the new AddChild method
// to specify the tab name.

// Dependencies:
// 	none

// Use of this code is permitted in all shareware as long as credit
// is given.  For use in commercial software please contact me at
// twalker@cc.edu.


#pragma once

class TTabView : public BView
{
public:
			TTabView(BRect inFrame, const char *inName, ulong inresizingMode, ulong inFlags);
			~TTabView();
	virtual void 	Draw(BRect inUpdateRect);
	virtual void	AddChild(BView*,const char*);
	virtual void	AddChild(BView*);
	virtual void	AttachedToWindow();
	virtual void	MouseDown(BPoint);
private:
	BList	*mLabels;
	BList	*mViews;
	long	mCurrent;
	long	mBehavior;

};

