#include <Window.h>
#include "TWindow.h"
/*
* $Log: TWindow.cpp,v $
* Revision 1.1  1997/04/05 15:56:04  elvis
* Initial revision
*
*/

#include "TStatsView.h"
#include "TTeamView.h"
#include "TProcessView.h"
#include "TTabView.h"
#include "TView.h"
#include "colors.h"


TWindow::TWindow(BRect frame, const char* title, window_type type, 
					ulong flags, ulong workspaces)
	: BWindow(frame,title, type, 
				B_NOT_RESIZABLE|B_NOT_ZOOMABLE, workspaces)
{
	BRect	theViewFrame = frame;
	Lock();

	theViewFrame.OffsetTo(0,0);
	TView	*theMainView = new TView(theViewFrame, "Main View", B_FOLLOW_ALL,B_WILL_DRAW);
	AddChild(theMainView);
	theMainView->SetViewColor(mdGray);

	theViewFrame.InsetBy(5,5);
	TTabView	*theTabView = new TTabView(theViewFrame, "Tab View", B_FOLLOW_ALL,B_WILL_DRAW);
	theMainView->AddChild(theTabView);
	
	theViewFrame.InsetBy(5,5);
	TStatsView *theStatsView = new TStatsView(theViewFrame, "Statistics", B_FOLLOW_ALL,B_WILL_DRAW|B_PULSE_NEEDED);
	theStatsView->SetViewColor(theTabView->ViewColor());
	theTabView->AddChild(theStatsView);	
	
//	TTeamView *theTeamView = new TTeamView(theViewFrame, "Teams", B_FOLLOW_ALL,B_WILL_DRAW|B_PULSE_NEEDED);
//	theTeamView->SetViewColor(theTabView->ViewColor());
//	theTabView->AddChild(theTeamView);	
	
//	TProcessView *theProcessView = new TProcessView(theViewFrame, "Processes", B_FOLLOW_ALL,B_WILL_DRAW|B_PULSE_NEEDED);
//	theProcessView->SetViewColor(theTabView->ViewColor());
//	theTabView->AddChild(theProcessView);	
	
	SetPulseRate(300000);

	Unlock();
}


bool 
TWindow::QuitRequested()
{
	be_app->PostMessage(B_QUIT_REQUESTED);
	return TRUE;
}